<template>
  <div class="podcasts">
    <PodcastsTitle />
    <Transition name="grow">
      <PodcastsAdmin v-if="isAdmin"/>
    </Transition>
    <h3 class="note text-shadow">
      *אין להסתמך על הפודקאסטים בלבד, אלא על
      <router-link to="/units">החוברת החילית</router-link>*
    </h3>
    <easy-spinner style="margin: 2.5rem" size="5em" type="circular" color="rgb(170, 170, 200)" v-if="!fetchedPodcasts" />
    <div class="podcasts-container">
      <Podcast v-for="podcast in podcasts" :key="podcast.id" :data="podcast" :ref="podcast.id"/>
    </div>
  </div>
</template>

<script>
import PodcastsTitle from './podcasts-title.vue'
import PodcastsAdmin from './podcasts-admin.vue'
import Podcast from './podcast.vue'

export default {
  methods: {
    fadePodcasts() {
      Promise.resolve().then(()=> {
        this.fadePodcastsOut()
        this.fadePodcastsIn()
      })
    },
    fadePodcastsOut() {
      for (let ref in this.$refs) {
        this.$refs[ref].show = false
      }
    },
    fadePodcastsIn() {
      let timeout = 0
      for (let ref in this.$refs) {
        setTimeout(() => {
          this.$refs[ref].show = true
        }, timeout)
        timeout += 200
      }
    },
  },
  computed: {
    podcasts() {
      return this.$store.state.podcasts
    },
    fetchedPodcasts() {
      if (this.$store.state.fetchedPodcasts) {
        this.fadePodcasts()
      }
      return this.$store.state.fetchedPodcasts
    },
    isAdmin() {
      return this.$store.state.user != null
    }
  },
  components: {
    PodcastsTitle,
    PodcastsAdmin,
    Podcast
  }
}
</script>

<style>
@media screen and (max-width: 700px) {
  .podcasts {
    font-size: .7em;
  }
}

.note {
  margin: 1em;
  margin-bottom: 0;
  font-weight: bold;
  text-align: center;
  font-size: 1.5em;
  color: var(--blue);
}

.podcasts {
  padding-top: var(--headerHeight);
  min-height: calc(100% - var(--footerHeight));
  position: relative;
  display: flex;
  flex-direction: column;
  align-items: center;
}

.podcasts-container {
  width: 100%;
  padding: 2em;
}

.podcast-enter-active,
.podcast-leave-active {
  position: relative;
  transition: left 1s ease, opacity 1s ease;
  left: 0;
}

.podcast-enter-from,
.podcast-leave-to {
  opacity: 0;
  left: 3em;
}

audio::-webkit-media-controls-play-button,
audio::-webkit-media-controls-panel {
  background-color: #fafaff;
}
</style>